searchData={"items":[{"type":"module","title":"Modbuzz","doc":"Documentation for `Modbuzz`.","ref":"Modbuzz.html"},{"type":"function","title":"Modbuzz.hello/0","doc":"Hello world.","ref":"Modbuzz.html#hello/0"},{"type":"function","title":"Examples - Modbuzz.hello/0","doc":"iex> Modbuzz.hello()\n    :world","ref":"Modbuzz.html#hello/0-examples"},{"type":"protocol","title":"Modbuzz.PDU","doc":"MODBUS Protocol Data Unit.\n\nEach PDU is documented, for example, in `Modbuzz.PDU.ReadCoils`.","ref":"Modbuzz.PDU.html"},{"type":"function","title":"Modbuzz.PDU.decode/2","doc":"Decodes the PDU binary into tuple","ref":"Modbuzz.PDU.html#decode/2"},{"type":"function","title":"Modbuzz.PDU.encode/1","doc":"Encodes the request into a PDU binary","ref":"Modbuzz.PDU.html#encode/1"},{"type":"type","title":"Modbuzz.PDU.t/0","doc":"All the types that implement this protocol.","ref":"Modbuzz.PDU.html#t:t/0"},{"type":"module","title":"Modbuzz.TCP.Client","doc":"This is MODBUS TCP client `GenServer` module.","ref":"Modbuzz.TCP.Client.html"},{"type":"function","title":"Modbuzz.TCP.Client.call/4","doc":"Makes a synchronous call to the server and waits for a response.\nOnly available when active: false.\n\nThe response type is the same as `Modbuzz.PDU.decode/2` of request or `{:error, reason :: term()}`.","ref":"Modbuzz.TCP.Client.html#call/4"},{"type":"function","title":"Examples - Modbuzz.TCP.Client.call/4","doc":"iex> alias Modbuzz.PDU.{WriteSingleCoil, ReadCoils}\n    [Modbuzz.PDU.WriteSingleCoil, Modbuzz.PDU.ReadCoils]\n    iex> Modbuzz.TCP.Client.call(%WriteSingleCoil{output_address: 0 , output_value: true})\n    {:ok, nil}\n    iex> Modbuzz.TCP.Client.call(%ReadCoils{starting_address: 0 , quantity_of_coils: 1})\n    {:ok, [true]}","ref":"Modbuzz.TCP.Client.html#call/4-examples"},{"type":"function","title":"Modbuzz.TCP.Client.cast/4","doc":"Casts a request to the server without waiting for a response.\nOnly available when active: true.\n\nThis function always returns :ok regardless of whether the destination server (or node) exists.\nTherefore it is unknown whether the destination server successfully handled the request.\n\nIts response is sent as a meessage, looks like\n\n```\n{:modbuzz, unit_id, request, response}\n```\n\nThe response type is the same as `Modbuzz.PDU.decode/2` of request or `{:error, reason :: term()}`.","ref":"Modbuzz.TCP.Client.html#cast/4"},{"type":"function","title":"Examples - Modbuzz.TCP.Client.cast/4","doc":"iex> alias Modbuzz.PDU.{WriteSingleCoil, ReadCoils}\n    [Modbuzz.PDU.WriteSingleCoil, Modbuzz.PDU.ReadCoils]\n    iex> Modbuzz.TCP.Client.cast(%WriteSingleCoil{output_address: 0 , output_value: true})\n    :ok\n    iex> Modbuzz.TCP.Client.cast(%ReadCoils{starting_address: 0 , quantity_of_coils: 1})\n    :ok","ref":"Modbuzz.TCP.Client.html#cast/4-examples"},{"type":"function","title":"Modbuzz.TCP.Client.start_link/1","doc":"Starts a Elixir.Modbuzz.TCP.Client GenServer process linked to the current process.","ref":"Modbuzz.TCP.Client.html#start_link/1"},{"type":"function","title":"Options - Modbuzz.TCP.Client.start_link/1","doc":"* `:name` - used for name registration as described in the \"Name\n    registration\" section in the documentation for `GenServer`\n\n  * `:address` - passed through to `:gen_tcp.connect/4`\n\n  * `:port` - passed through to `:gen_tcp.connect/4`\n\n  * `:active` - passed through to `:gen_tcp.connect/4`","ref":"Modbuzz.TCP.Client.html#start_link/1-options"},{"type":"function","title":"Examples - Modbuzz.TCP.Client.start_link/1","doc":"iex> Modbuzz.TCP.Client.start_link([address: {192, 168, 0, 123}, port: 502, active: false])","ref":"Modbuzz.TCP.Client.html#start_link/1-examples"},{"type":"behaviour","title":"Modbuzz.TCP.TransportBehaviour","doc":"This behaviour provides the exact same interface as :gen_tcp.\n\nWe use `identifier()` as socket type for unit tests.","ref":"Modbuzz.TCP.TransportBehaviour.html"},{"type":"callback","title":"Modbuzz.TCP.TransportBehaviour.close/1","doc":"","ref":"Modbuzz.TCP.TransportBehaviour.html#c:close/1"},{"type":"callback","title":"Modbuzz.TCP.TransportBehaviour.connect/4","doc":"","ref":"Modbuzz.TCP.TransportBehaviour.html#c:connect/4"},{"type":"callback","title":"Modbuzz.TCP.TransportBehaviour.recv/3","doc":"","ref":"Modbuzz.TCP.TransportBehaviour.html#c:recv/3"},{"type":"callback","title":"Modbuzz.TCP.TransportBehaviour.send/2","doc":"","ref":"Modbuzz.TCP.TransportBehaviour.html#c:send/2"},{"type":"module","title":"Modbuzz.PDU.ReadCoils","doc":"`Modbuzz.PDU` implementation of ReadCoils.","ref":"Modbuzz.PDU.ReadCoils.html"},{"type":"module","title":"Request type - Modbuzz.PDU.ReadCoils","doc":"- `t()`","ref":"Modbuzz.PDU.ReadCoils.html#module-request-type"},{"type":"module","title":"Response types - Modbuzz.PDU.ReadCoils","doc":"- `{:ok, [] | [boolean()]}`\n  - `{:error, exception: 1..4}`","ref":"Modbuzz.PDU.ReadCoils.html#module-response-types"},{"type":"type","title":"Modbuzz.PDU.ReadCoils.t/0","doc":"","ref":"Modbuzz.PDU.ReadCoils.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.ReadDiscreteInputs","doc":"`Modbuzz.PDU` implementation of ReadDiscreteInputs.","ref":"Modbuzz.PDU.ReadDiscreteInputs.html"},{"type":"module","title":"Request type - Modbuzz.PDU.ReadDiscreteInputs","doc":"- `t()`","ref":"Modbuzz.PDU.ReadDiscreteInputs.html#module-request-type"},{"type":"module","title":"Response types - Modbuzz.PDU.ReadDiscreteInputs","doc":"- `{:ok, [] | [boolean()]}`\n  - `{:error, exception: 1..4}`","ref":"Modbuzz.PDU.ReadDiscreteInputs.html#module-response-types"},{"type":"type","title":"Modbuzz.PDU.ReadDiscreteInputs.t/0","doc":"","ref":"Modbuzz.PDU.ReadDiscreteInputs.html#t:t/0"},{"type":"module","title":"Modbuzz.PDU.WriteSingleCoil","doc":"`Modbuzz.PDU` implementation of WriteSingleCoil.","ref":"Modbuzz.PDU.WriteSingleCoil.html"},{"type":"module","title":"Request type - Modbuzz.PDU.WriteSingleCoil","doc":"- `t()`","ref":"Modbuzz.PDU.WriteSingleCoil.html#module-request-type"},{"type":"module","title":"Response types - Modbuzz.PDU.WriteSingleCoil","doc":"- `{:ok, nil}`\n  - `{:error, exception: 1..4}`","ref":"Modbuzz.PDU.WriteSingleCoil.html#module-response-types"},{"type":"type","title":"Modbuzz.PDU.WriteSingleCoil.t/0","doc":"","ref":"Modbuzz.PDU.WriteSingleCoil.html#t:t/0"},{"type":"extras","title":"Modbuzz","doc":"# Modbuzz\n\nModbuzz is yet another MODBUS TCP library.","ref":"readme.html"},{"type":"extras","title":"MODBUS References - Modbuzz","doc":"- WEB: https://modbus.org/\n  - PDF: [MODBUS APPLICATION PROTOCOL SPECIFICATION V1.1b3](https://modbus.org/docs/Modbus_Application_Protocol_V1_1b3.pdf)\n  - PDF: [MODBUS MESSAGING ON TCP/IP IMPLEMENTATION GUIDE V1.0b](https://modbus.org/docs/Modbus_Messaging_Implementation_Guide_V1_0b.pdf)","ref":"readme.html#modbus-references"},{"type":"extras","title":"Installation - Modbuzz","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `modbuzz` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:modbuzz, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"License - Modbuzz","doc":"This project is licensed under the Apache-2.0 license.\n\nAnd this project follows the REUSE compliance.\nFor more details, see the [REUSE SOFTWARE](https://reuse.software/).","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}